import java.awt.*;
import javax.swing.*;
import java.util.*;
import java.awt.event.*;

/**
 * Title:        spider - SpiderBox
 * Description:  Projekt zur Einfuehrung der Objektorientierten Programmierung
 * Copyright:    Copyright (c) 2021
 * Company:      mezdata
 * @author Oliver Mezger
 * @version 1.3
 */

public class SpiderBox extends JFrame {
  private MyPanel mPan = new MyPanel();
 
  public SpiderBox() {
    getContentPane().add(mPan);
    addWindowListener(new WindowAdapter(){  // Objekt soll beendet werden koennen
       public void windowClosing(WindowEvent e) {
         System.exit(0);
       }
    }); 
  }  
}

class MyPanel extends JPanel implements Runnable { // zusätzliche Schnittstelle Runnable
  private JLabel versi = new JLabel("Spider 1.3 (c) Oliver Mezger");
  private JButton exit = new JButton("Exit");
  private int ortX= 50,ortY=50;
  private Spider anna = new Spider(100,100,50,Color.red);
  private Spider bert = new Spider(200,200,40,Color.green);
  
  public MyPanel(){
    setBackground(Color.yellow);
    setLayout(new FlowLayout());
    add(versi);
    add(exit);
    exit.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mouseClicked(MouseEvent e) {
        System.exit(0);
      }
    });
    addMouseListener(new java.awt.event.MouseAdapter() {
      public void mousePressed(MouseEvent e) {
        canvas_mousePressed(e);
      }
    });
    Thread liveDaemon = new Thread(this);  // neuen Thread erzeugen
    liveDaemon.start();  // Thread starten
  }
  public void paintComponent(Graphics g)  {
    super.paintComponent(g);
    g.setColor(Color.blue);
    g.fillOval(ortX-6, ortY-6, 12, 12);
    anna.malen(g);
    bert.malen(g);
  }  
  public void canvas_mousePressed(MouseEvent e) {
    ortX=e.getX();
    ortY=e.getY();
    anna.gehezu(ortX,ortY);
    bert.gehezu(ortX,ortY);
    repaint();
  }
  public void run() {// das ist der Thread, hier steckt das Leben drin
    while (true){ // solange immer
      anna.leben();  // anna leben lassen
      bert.leben();  // bert leben lasssen
      repaint();     // neu zeichnen
      try {
        Thread.sleep (200);  // ein wenig schlafen
      }
      catch (InterruptedException ex){
      }
    }  
  }
}